﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using MonoGameTemplate.Engine.Prefabs;

namespace MonoGameTemplate.Scenes
{
    class MainMenu : Scene
    {
        public MainMenu()
        {
            name = "Main Menu"; new Scenes.Platformer();
            bounds = new Rectangle(0, 0, 1920, 1080);
            backgroundColor = Color.LightBlue;
            camera = new Camera(this);
            camera.Zoom(1);
        }

        public override void Load()
        {
            // New Game Button
            //Button newGameButton = new Button(Assets.newGameButton, NewGameButtonClicked); // With Texture
            Button newGameButton = new Button(Color.Blue, 64, 64, NewGameButtonClicked); // Solid Color
            AddUIObject(newGameButton, this, 32, 32);

            // Images
            for (int i = 0; i < 500; i++)
            {
                Color color = new Color(new Vector3(Geometry.RandomFloat(0, 1), Geometry.RandomFloat(0, 1), Geometry.RandomFloat(0, 1)));
                Image image = new Image(color, Geometry.RandomInt(1, 256), Geometry.RandomInt(1, 256));
                AddUIObject(image, this, Geometry.RandomInt(0, bounds.Width), Geometry.RandomInt(0, bounds.Height));
            }
            
        }

        public string NewGameButtonClicked()
        {
            LoadScene(Assets.level01);
            return null;
        }

        // Update
        public override void Update(GameTime gameTime)
        {
            foreach (GameObject obj in uiObjects)
            {
                obj.sprite.color = new Color(new Vector3(Geometry.RandomFloat(0, 1), Geometry.RandomFloat(0, 1), Geometry.RandomFloat(0, 1)));
                obj.transform.position = new Vector2(Geometry.RandomInt(-200, bounds.Width), Geometry.RandomInt(-200, bounds.Height));
            }

            // Controls
            if (Controller.IsKeyDown(Keys.Escape)) // Exit game
            {
                Program.game.Exit();
            }

            // Mouse Clicks
            if (Controller.IsLeftButtonUp())
            {
                ClickUIObjects(Controller.GetMousePosition());
            }
        }
    }
}
